/*

Copyleft (L) 2004  AlterWare Beast Inc.   >;->

Module Name:        DbgPrnHk.c
Abstract:           
Authors:            Alter
Environment:        kernel mode only

 */

#include "DbgPrnHk.h"
//#include "bin_patch.h"
#include "regtools.h"

PDRIVER_OBJECT DriverObject;
PDEVICE_OBJECT DbgPrnHkDevice = NULL;

UNICODE_STRING      unicodeDeviceNameDos;

CHAR Copyright[] = "DbgPrint hook driver v0.3 Copyright (c) 2004 by Alexander A. Telyatnikov\n"
                   "home site: http://www.alter.org.ua\n";

//PCHAR Buffer = NULL;
PDbgPrnHk_GetMessages_USER_OUT MsgBuffer = NULL;
LARGE_INTEGER ReadPosition = {0, 0};
LARGE_INTEGER WritePosition = {0, 0};
ULONG BufferSize = 1024*1024;
ULONG BufferSizeMask = (1024*1024/sizeof(DbgPrnHk_GetMessages_USER_OUT))-1;
BOOLEAN CheckIrql = FALSE;

typedef
ULONG
(*PDBG_PRINT_API) (
    PCH Format,
    ...
    );

typedef
NTSTATUS
(*PDEBUG_PRINT_API) (
    IN PSTRING Output
    );

typedef
NTSTATUS
(*PDEBUG_PRINTEX_API) (
    IN PSTRING Output,
    IN ULONG Arg1,
    IN ULONG Arg2
    );

PDBG_PRINT_API     OrigDbgPrint = NULL;
PDEBUG_PRINT_API   OrigDebugPrint = NULL;
PDEBUG_PRINTEX_API OrigDebugPrintEx = NULL;
PUCHAR             PatchAddress = NULL;
PVOID              pvDbgPrintExWithPrefix = NULL;

NTSTATUS
HookDebugPrint (
    IN PSTRING Output
    );

NTSTATUS
HookDebugPrintEx (
    IN PSTRING Output,
    IN ULONG Arg1,
    IN ULONG Arg2
    );

VOID
PrintToBuffer(
    PCHAR Text,
    ULONG Length
    );

ULONG
ReadFromBuffer(
    IN OUT PDbgPrnHk_GetMessages_USER_OUT UserBuffer,
    IN ULONG Length
    );

PVOID
KernelGetModuleBase(
    PCHAR  pModuleName
    );

PVOID
KernelGetProcAddress(
    PVOID ModuleBase,
    PCHAR pFunctionName
    );

ULONG  MajorVersion = 0;
ULONG  MinorVersion = 0;
ULONG  BuildNumber  = 0;


#define WinVer_IsNT   (MajorVersion==0x04)
#define WinVer_Is2k   (MajorVersion==0x05 && MinorVersion==0x00)
#define WinVer_IsXP   (MajorVersion==0x05 && MinorVersion==0x01)
#define WinVer_IsXPp  (MajorVersion==0x05 && MinorVersion>=0x01)
#define WinVer_IsdNET (MajorVersion==0x05 && MinorVersion==0x02)

/*
    DriverObject - Driver object.

    Returns:    NTSTATUS
 */

NTSTATUS
DriverEntry(
    IN PDRIVER_OBJECT driverObject,
    IN PUNICODE_STRING RegistryPath
    )
{
    CCHAR       deviceNameBuffer[MAXIMUM_FILENAME_LENGTH];
    CCHAR       deviceNameBufferDos[MAXIMUM_FILENAME_LENGTH];
    ANSI_STRING         deviceName;
    ANSI_STRING         deviceNameDos;
    UNICODE_STRING      unicodeDeviceName;
    ULONG               i;
    NTSTATUS            status;
    PVOID               ModuleBase;
//    BOOL bRet;
    ULONG               count_50_e8;
    PUCHAR              f_ptr;
    BOOLEAN             found = FALSE;
    HANDLE              hReg = NULL;

    DriverObject = driverObject;
    PsGetVersion(&MajorVersion, &MinorVersion, &BuildNumber, NULL);
    KdPrint(("DbgPrnHkInitialize: OS ver %x.%x (%d)\n", MajorVersion, MinorVersion, BuildNumber));

    for(i=0; i<=IRP_MJ_MAXIMUM_FUNCTION; i++)
        DriverObject->MajorFunction[i] = NULL;

    // Set up the device driver entry points.
    DriverObject->MajorFunction[IRP_MJ_CREATE] = DbgPrnHkCreateClose;
    DriverObject->MajorFunction[IRP_MJ_CLEANUP] = DbgPrnHkCreateClose;
    DriverObject->MajorFunction[IRP_MJ_CLOSE] = DbgPrnHkCreateClose;
    DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = DbgPrnHkDeviceControl;

    DriverObject->DriverUnload = DbgPrnHkUnload;

    sprintf((PCHAR)&deviceNameBuffer, NT_DbgPrnHk_NAME);
    KdPrint(("DbgPrnHkInitialize: Checking \\Device\\DbgPrnHk\n"));
    RtlInitAnsiString(&deviceName, (PCHAR)&deviceNameBuffer);
    RtlAnsiStringToUnicodeString(&unicodeDeviceName, &deviceName, TRUE);
    // Create the device object for DbgPrnHk.
    status = IoCreateDevice(DriverObject, 0 /*sizeof(LM_DEVICE_EXTENSION)*/, &unicodeDeviceName,
                        FILE_DEVICE_UNKNOWN, NULL, FALSE, &DbgPrnHkDevice);
    if(!NT_SUCCESS(status)) {
        RtlFreeUnicodeString(&unicodeDeviceName);
        return status;
    }

    sprintf((PCHAR)&deviceNameBufferDos, NT_DbgPrnHk_DOS_NAME);
    KdPrint(("DbgPrnHkInitialize: Checking \\DosDevices\\DbgPrnHk\n"));
    RtlInitAnsiString(&deviceNameDos, (PCHAR)&deviceNameBufferDos);
    RtlAnsiStringToUnicodeString(&unicodeDeviceNameDos, &deviceNameDos, TRUE);
    status = IoCreateSymbolicLink (&unicodeDeviceNameDos, &unicodeDeviceName);
    if(!NT_SUCCESS(status)) {
        IoDeleteDevice(DbgPrnHkDevice);
        RtlFreeUnicodeString(&unicodeDeviceName);
        RtlFreeUnicodeString(&unicodeDeviceNameDos);
        return status;
    }
    RtlFreeUnicodeString(&unicodeDeviceName);

    // get NTOSKRNL.EXE exports
    ModuleBase = KernelGetModuleBase ("NTOSKRNL.EXE");
    KdPrint(("DbgPrnHkInitialize: NTOSKRNL.EXE ModuleBase %#x\n", ModuleBase));
    if(ModuleBase) {
        OrigDbgPrint = (PDBG_PRINT_API)KernelGetProcAddress(ModuleBase, "DbgPrint");
        pvDbgPrintExWithPrefix = KernelGetProcAddress(ModuleBase, "vDbgPrintExWithPrefix");
    }
    KdPrint(("DbgPrnHkInitialize: DbgPrint              Address %#x\n", OrigDbgPrint));
    KdPrint(("DbgPrnHkInitialize: vDbgPrintExWithPrefix Address %#x\n", pvDbgPrintExWithPrefix));
    if(OrigDbgPrint) {
        KdDump(OrigDbgPrint, 0x100);
    }

    // get buffer size
    // Note, BufferSize must be power of 2
    BufferSize = 1024*1024;
    status = RegGetKeyHandle(NULL, NT_DBGPRNHK_REG_PATH, &hReg);
    if(hReg) {
        ULONG tmp;
        
        RegGetDword(hReg, NULL, NT_DBGPRNHK_REG_BUFFER_SIZE_VAL, &BufferSize);
        BufferSize *= 1024;
        while(BufferSize) {
            BufferSize >>= 1;
            i++;
        }
        if(i>=10) {
            i--;
        } else {
            i = 10;
        }
        BufferSize = ((ULONG)1) << i;

        tmp = 0;
        RegGetDword(hReg, NULL, NT_DBGPRNHK_REG_CHECK_IRQL_VAL, &tmp);
        if(tmp) {
            CheckIrql = TRUE;
        }
    }

    BufferSizeMask = BufferSize / sizeof(DbgPrnHk_GetMessages_USER_OUT) - 1;
    MsgBuffer = (PDbgPrnHk_GetMessages_USER_OUT)
        ExAllocatePool(NonPagedPool, BufferSize);
    if(!MsgBuffer) {
        DbgPrnHkUnload(DriverObject);
        return STATUS_INSUFFICIENT_RESOURCES;
    }

    if(pvDbgPrintExWithPrefix) {
        /*
          Under XP/2003 DebugPrint is called from vDbgPrintExWithPrefix() function.
          The ASM code of this call looks like this:

          PUSH EAX
          CALL xxxxxxxx
          CMP EAX,0x80000003

          We shall look for corresponding byte sequence
        */
        KdPrint(("Mode XP\n"));
        f_ptr = (PUCHAR)pvDbgPrintExWithPrefix;
        KdPrint(("search @ %#x\n", f_ptr));
        for(i=0; i<0xff; i++) {
            if(f_ptr[i]   == 0x50 &&
               f_ptr[i+1] == 0xe8 &&
               f_ptr[i+6] == 0x3d &&
               (*(PULONG)(f_ptr+i+7)) == 0x80000003) {
                found = TRUE;
                break;
            }
        }
    } else
    if(MajorVersion == 5) {
        /*
          Under 2000 DebugPrint is called from DbgPrint() function.
          The ASM code of this call looks like this (same as XP):

          PUSH EAX
          CALL xxxxxxxx
          CMP EAX,0x80000003

          We shall look for corresponding byte sequence
        */
        KdPrint(("Mode v5\n"));
        f_ptr = (PUCHAR)OrigDbgPrint;
        KdPrint(("search @ %#x\n", f_ptr));
        for(i=0; i<0xff; i++) {
            if(f_ptr[i]   == 0x50 &&
               f_ptr[i+1] == 0xe8 &&
               f_ptr[i+6] == 0x3d &&
               (*(PULONG)(f_ptr+i+7)) == 0x80000003) {
                found = TRUE;
                break;
            }
        }
    } else {
        /*
          Under NT4 DebugPrint is called from DbgPrint() function.
          The ASM code of this call looks like this (same as XP):

          PUSH EAX
          CALL xxxxxxxx

          this call is preceded with very similar call to vsnprintf():

          PUSH EAX
          CALL yyyyyyyy

          We shall look for the 2nd PUSH EAX/CALL xxxxxxxx byte sequence
        */
        KdPrint(("Mode other\n"));
        f_ptr = (PUCHAR)OrigDbgPrint;
        KdPrint(("search @ %#x\n", f_ptr));
        count_50_e8 = 0;
        for(i=0; i<0xff; i++) {
            if(f_ptr[i]   == 0x50 &&
               f_ptr[i+1] == 0xe8) {
                count_50_e8++;
                if(count_50_e8 == 2) {
                    found = TRUE;
                    break;
                }
            }
        }
    }
    if(!found) {
        DbgPrnHkUnload(DriverObject);
        return STATUS_INSUFFICIENT_RESOURCES;
    }

    KdPrint(("DbgPrnHkInitialize: Patching call to DebugPrint @ %#x\n", f_ptr+i+2));
    //========================================
    // Clear WriteProtection bit in CR0:
    _asm pushad
    _asm mov  ebx, cr0
    _asm push ebx
    _asm and  ebx, ~0x10000  // reset WriteProtect bit
    _asm mov  cr0, ebx

    _asm pushfd
    _asm cli

    PatchAddress = f_ptr+i+2;
    // save CALL address (relative)
    OrigDebugPrint = (PDEBUG_PRINT_API)(*(PULONG)(PatchAddress) + (ULONG)(PatchAddress+4));
    KdPrint(("DbgPrnHkInitialize: orig call addr %#x\n", OrigDebugPrint));
    if(pvDbgPrintExWithPrefix) {
        KdPrint(("DbgPrnHkInitialize: XP KdPrintEx\n"));
        OrigDebugPrintEx = (PDEBUG_PRINTEX_API)OrigDebugPrint;
        // patch CALL address (relative)
        *(PULONG)(PatchAddress) = (ULONG)HookDebugPrintEx - (ULONG)(PatchAddress+4);
    } else {
        KdPrint(("DbgPrnHkInitialize: std KdPrint\n"));
        // patch CALL address (relative)
        *(PULONG)(PatchAddress) = (ULONG)HookDebugPrint - (ULONG)(PatchAddress+4);
    }

    _asm popfd

    // Restore WriteProtection bit in CR0:
    _asm pop ebx
    _asm mov cr0, ebx
    _asm popad

    KdPrint(("DbgPrnHkInitialize: Patched...\n"));

    return STATUS_SUCCESS;

} // DriverEntry()

/*
    This routine services open commands. It establishes
    the driver's existance by returning status success.

    Arguments:

    DeviceObject - Context for the activity.
    Irp          - The device control argument block.

    Returns:    NT Status
 */
NTSTATUS
DbgPrnHkCreateClose(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
    return STATUS_SUCCESS;
} // end DbgPrnHkCreateClose()


/*
    This device control dispatcher handles only the disk performance
    device control. All others are passed down to the disk drivers.
    The disk performane device control returns a current snapshot of
    the performance data.

    Arguments:

    DeviceObject - Context for the activity.
    Irp          - The device control argument block.

    Returns:    NT Status
 */
NTSTATUS
DbgPrnHkDeviceControl(
    PDEVICE_OBJECT DeviceObject,
    PIRP Irp
    )
{
//    KdPrint(("DbgPrnHkDeviceControl\n"));
//    PLM_DEVICE_EXTENSION deviceExtension = (PLM_DEVICE_EXTENSION)DeviceObject->DeviceExtension;
    PIO_STACK_LOCATION  irpStack = IoGetCurrentIrpStackLocation(Irp);
    ULONG               ioctlCode;
    NTSTATUS            status;
    ULONG               length;

    Irp->IoStatus.Information = 0;
    ioctlCode = irpStack->Parameters.DeviceIoControl.IoControlCode;
    switch (ioctlCode) {
    case IOCTL_DbgPrnHk_GetMessages: {
        //KdPrint(("DbgPrnHk: GetMessages\n"));
        // We have <DeviceName> & its attributes.
        PDbgPrnHk_GetMessages_USER_OUT obuffer;

        length = sizeof(DbgPrnHk_GetMessages_USER_OUT); 
        CHECK_OUT_BUFFER();

        obuffer = (PDbgPrnHk_GetMessages_USER_OUT)(Irp->AssociatedIrp.SystemBuffer);

        length = ReadFromBuffer(obuffer,
            irpStack->Parameters.DeviceIoControl.OutputBufferLength);

        Irp->IoStatus.Information = length;
        status = STATUS_SUCCESS;
        break;
    }
    case IOCTL_DbgPrnHk_GetVersion: {
        PDbgPrnHk_GetVersion_USER_OUT obuffer;

        length = sizeof(DbgPrnHk_GetVersion_USER_OUT); 
        CHECK_OUT_BUFFER();

        obuffer = (PDbgPrnHk_GetVersion_USER_OUT)(Irp->AssociatedIrp.SystemBuffer);
        obuffer->Major = PROD_VER_MJ;
        obuffer->Minor = PROD_VER_MN;
        obuffer->Sub   = PROD_VER_NSUB;

        Irp->IoStatus.Information = length;
        status = STATUS_SUCCESS;
        break;
    }
    case IOCTL_DbgPrnHk_PostMessage: {

        length = irpStack->Parameters.DeviceIoControl.InputBufferLength;

        PrintToBuffer((PCHAR)(Irp->AssociatedIrp.SystemBuffer), length);

        Irp->IoStatus.Information = length;
        status = STATUS_SUCCESS;
        break;
    }
    default:

        status = STATUS_INVALID_DEVICE_REQUEST;
        break;
    }

DbgPrnHkSpecDevCtrlCompleteRequest:

    Irp->IoStatus.Status = status;    // Update IRP with completion status.
    IoCompleteRequest(Irp, IO_DISK_INCREMENT);    // Complete the request.
//    KdPrint(( "DbgPrnHkDeviceControl: Status is %lx\n", status));
    return status;

} // end DbgPrnHkDeviceControl()


/*
    This routine services driver unload commands.

    Arguments:

    DeviceObject - Context for the activity.

    Returns:    none
 */
VOID
DbgPrnHkUnload(
    IN PDRIVER_OBJECT DriverObject
    )
{
    LARGE_INTEGER Delay;
    ULONG Addr;

    Delay.QuadPart = 10*1000*1000; // 1 sec

    if(pvDbgPrintExWithPrefix) {
        KdPrint(("DbgPrnHkInitialize: Prepare to Unpatch XP KdPrintEx\n"));
        Addr = (ULONG)HookDebugPrintEx - (ULONG)(PatchAddress+4);
    } else {
        Addr = (ULONG)HookDebugPrint - (ULONG)(PatchAddress+4);
    }

    while(PatchAddress) {
        if(*(PULONG)(PatchAddress) == Addr) {
            KdPrint(("DbgPrnHkInitialize: UnPatching call to DebugPrint @ %#x\n", PatchAddress-2));
            //========================================
            // Clear WriteProtection bit in CR0:
            _asm pushad
            _asm mov  ebx, cr0
            _asm push ebx
            _asm and  ebx, ~0x10000  // reset WriteProtect bit
            _asm mov  cr0, ebx

            _asm pushfd
            _asm cli

            // restore CALL address (relative)
            if(pvDbgPrintExWithPrefix) {
                KdPrint(("DbgPrnHkInitialize: Unpatch XP KdPrintEx\n"));
                *(PULONG)(PatchAddress) = (ULONG)OrigDebugPrintEx - (ULONG)(PatchAddress+4);
            } else {
                *(PULONG)(PatchAddress) = (ULONG)OrigDebugPrint - (ULONG)(PatchAddress+4);
            }

            _asm popfd

            // Restore WriteProtection bit in CR0:
            _asm pop ebx
            _asm mov cr0, ebx
            _asm popad

            KdPrint(("DbgPrnHkInitialize: UnPatched...\n"));
            break;
        }
        KdPrint(("DbgPrnHkInitialize: wait for Unpatch...\n"));
        KeDelayExecutionThread(KernelMode, FALSE, &Delay);
    }

    if(MsgBuffer)
        ExFreePool(MsgBuffer);

    IoDeleteSymbolicLink(&unicodeDeviceNameDos);
    
    RtlFreeUnicodeString(&unicodeDeviceNameDos);

    if(DbgPrnHkDevice) {
        IoDeleteDevice(DbgPrnHkDevice);
        DbgPrnHkDevice = NULL;
    }
    return;
} // end DbgPrnHkUnload()

VOID
PrintToBuffer(
    PCHAR Text,
    ULONG Length
    )
{
    ULONG PrevPos;
    ULONG i;
    ULONG to_write;

    while(Length)  {
        PrevPos = InterlockedIncrement((PLONG)&WritePosition.LowPart);
        if(!(PrevPos)) {
            InterlockedIncrement((PLONG)&WritePosition.HighPart);
        }
        PrevPos--;
        i = PrevPos & BufferSizeMask;
        if(WritePosition.HighPart > ReadPosition.HighPart) {
            if(WritePosition.LowPart >= ReadPosition.LowPart) {
                ReadPosition.QuadPart = WritePosition.QuadPart+1;
            }
        } else
        if(((i+1) & BufferSizeMask) == (ReadPosition.LowPart & BufferSizeMask)) {
            PrevPos = InterlockedIncrement((PLONG)&ReadPosition.LowPart);
            if(!(PrevPos)) {
                InterlockedIncrement((PLONG)&ReadPosition.HighPart);
            }
        }
        to_write = min(Length, MAX_MSG_SIZE);
        MsgBuffer[i].TimeStamp = KeQueryPerformanceCounter(NULL);
        MsgBuffer[i].Length    = (USHORT)to_write;
        MsgBuffer[i].ProcessId = PsGetCurrentProcessId();
        MsgBuffer[i].ThreadId  = PsGetCurrentThreadId();
        MsgBuffer[i].Irql      = KeGetCurrentIrql();
        MsgBuffer[i].CpuNumber = (UCHAR)KeGetCurrentProcessorNumber();

        __try {
            memcpy(&MsgBuffer[i].Msg[0], Text, to_write);
        } __except(EXCEPTION_EXECUTE_HANDLER) {
            MsgBuffer[i].Length = 0;
            break;
        }
        Text += to_write;
        Length -= to_write;
    }
    return;
} // end PrintToBuffer()

ULONG
ReadFromBuffer(
    IN OUT PDbgPrnHk_GetMessages_USER_OUT UserBuffer,
    IN ULONG Length
    )
{
    ULONG PrevPos;
    ULONG i;
    ULONG to_write = 0;

    while(Length >= sizeof(DbgPrnHk_GetMessages_USER_OUT))  {
        if(ReadPosition.QuadPart >= WritePosition.QuadPart) {
            break;
        }
        PrevPos = InterlockedIncrement((PLONG)&ReadPosition.LowPart);
        if(!(PrevPos)) {
            InterlockedIncrement((PLONG)&ReadPosition.HighPart);
        }
        PrevPos--;
        i = PrevPos & BufferSizeMask;
        __try {
            memcpy(UserBuffer, &MsgBuffer[i], sizeof(DbgPrnHk_GetMessages_USER_OUT));
        } __except(EXCEPTION_EXECUTE_HANDLER) {
            break;
        }
        UserBuffer++;
        to_write += sizeof(DbgPrnHk_GetMessages_USER_OUT);
        Length -= sizeof(DbgPrnHk_GetMessages_USER_OUT);
    }
    return to_write;
} // end ReadFromBuffer()

NTSTATUS
HookDebugPrint(
    IN PSTRING Output
    )
{
    if(Output)
        PrintToBuffer(Output->Buffer, Output->Length);
    if(!OrigDebugPrint)
        return STATUS_SUCCESS;
    if(CheckIrql && KeGetCurrentIrql() > DISPATCH_LEVEL)
        return STATUS_SUCCESS;
    return OrigDebugPrint(Output);
} // end HookDebugPrint()

NTSTATUS
HookDebugPrintEx(
    IN PSTRING Output,
    IN ULONG   Arg1,
    IN ULONG   Arg2
    )
{
    if(Output) {
        PrintToBuffer(Output->Buffer, Output->Length);
    }
    if(!OrigDebugPrintEx)
        return STATUS_SUCCESS;
    if(CheckIrql && KeGetCurrentIrql() > DISPATCH_LEVEL)
        return STATUS_SUCCESS;
    return OrigDebugPrintEx(Output, Arg1, Arg2);
} //end HookDebugPrintEx()

PVOID
KernelGetModuleBase(
    PCHAR  pModuleName
    )
{
    PVOID pModuleBase = NULL;

    __try
    {
        NTSTATUS status = STATUS_INSUFFICIENT_RESOURCES;
        ULONG    SystemInfoBufferSize = 0;
        PULONG   pSystemInfoBuffer = NULL;

        status = ZwQuerySystemInformation(SystemModuleInfo,
            &SystemInfoBufferSize,
            0,
            &SystemInfoBufferSize);

        if (!SystemInfoBufferSize)
            return NULL;

        pSystemInfoBuffer = (PULONG)ExAllocatePool(NonPagedPool, SystemInfoBufferSize);

        if (!pSystemInfoBuffer)
            return NULL;

        memset(pSystemInfoBuffer, 0, SystemInfoBufferSize);

        status = ZwQuerySystemInformation(SystemModuleInfo,
            pSystemInfoBuffer,
            SystemInfoBufferSize,
            &SystemInfoBufferSize);

        if (NT_SUCCESS(status))
        {
            PSYSTEM_MODULE_ENTRY pSysModuleEntry =((PSYSTEM_MODULE_INFORMATION)(pSystemInfoBuffer))->Module;
            ULONG i;
            
            for (i = 0; i <((PSYSTEM_MODULE_INFORMATION)(pSystemInfoBuffer))->Count; i++)
            {
                if (_stricmp(pSysModuleEntry[i].ModuleName + pSysModuleEntry[i].ModuleNameOffset, pModuleName) == 0)
                {
                    pModuleBase = pSysModuleEntry[i].ModuleBaseAddress;
                    break;
                }
            }
        }

        ExFreePool(pSystemInfoBuffer);
    }
    __except(EXCEPTION_EXECUTE_HANDLER)
    {
        pModuleBase = NULL;
    }

    return pModuleBase;
} // end KernelGetModuleBase()

PVOID
KernelGetProcAddress(
    PVOID ModuleBase,
    PCHAR pFunctionName
    )
{
    PVOID pFunctionAddress = NULL;
    
    __try
    {
        PIMAGE_DOS_HEADER dos =(PIMAGE_DOS_HEADER) ModuleBase;
        PIMAGE_NT_HEADERS nt  =(PIMAGE_NT_HEADERS)((ULONG) ModuleBase + dos->e_lfanew);

        PIMAGE_DATA_DIRECTORY expdir =(PIMAGE_DATA_DIRECTORY) nt->OptionalHeader.DataDirectory + IMAGE_DIRECTORY_ENTRY_EXPORT;
        ULONG                 size = expdir->Size;
        ULONG                 addr = expdir->VirtualAddress;

        PIMAGE_EXPORT_DIRECTORY exports =(PIMAGE_EXPORT_DIRECTORY)((ULONG) ModuleBase + addr);

        PULONG functions =(PULONG)((ULONG) ModuleBase + exports->AddressOfFunctions);
        PSHORT ordinals  =(PSHORT)((ULONG) ModuleBase + exports->AddressOfNameOrdinals);
        PULONG names     =(PULONG)((ULONG) ModuleBase + exports->AddressOfNames);
        ULONG  max_name  =exports->NumberOfNames;
        ULONG  max_func  =exports->AddressOfFunctions;

        ULONG i;

        for (i = 0; i < exports->AddressOfNames; i++)
        {
            ULONG ord = ordinals[i];
            if(i >= max_name || ord >= max_func) {
                return NULL;
            }
            if (functions[ord] < addr || functions[ord] >= addr + size)
            {
                if (strcmp((PCHAR) ModuleBase + names[i], pFunctionName)  == 0)
                {
                    pFunctionAddress =(PVOID)((PCHAR) ModuleBase + functions[ord]);
                    break;
                }
            }
        }
    }
    __except(EXCEPTION_EXECUTE_HANDLER)
    {
        pFunctionAddress = NULL;
    }

    return pFunctionAddress;
} // end KernelGetProcAddress()
