#include "windows.h"
#include "stdio.h"

#ifndef USER_MODE
#define USER_MODE
#endif //USER_MODE

#include "..\inc\DbgPrnHk.h"
#include "PostDbgMesg.h"

HANDLE h_DbgPrintHookDriver = NULL;

BOOLEAN
DbgDump_i_ConnectDriver()
{
    HANDLE h;
    
    if(h_DbgPrintHookDriver)
        return TRUE;

    h = CreateFile(NT_DbgPrnHk_USER_NAME, GENERIC_READ | GENERIC_WRITE,
                   /*FILE_SHARE_READ | FILE_SHARE_WRITE*/ 0,
                   NULL,
                   OPEN_EXISTING,
                   FILE_ATTRIBUTE_NORMAL/* | FILE_FLAG_NO_BUFFERING*/,  NULL);
    if(!h || h == (HANDLE)(-1)) {
        return FALSE;
    }
    h_DbgPrintHookDriver = h;
    return TRUE;
} // end DbgDump_i_ConnectDriver()

extern "C"
BOOLEAN
_cdecl
DbgDump_Printf(
    PCHAR Format,
    ...
    )
{
    ULONG returned;
    CHAR buff[2048];
    va_list ap;
    va_start(ap, Format);
    BOOLEAN retval;
    ULONG len;

    if(!DbgDump_i_ConnectDriver())
        return FALSE;

    len = _vsnprintf(buff, sizeof(buff), Format, ap);
    buff[sizeof(buff)-1] = 0;

    if(!DeviceIoControl(h_DbgPrintHookDriver, IOCTL_DbgPrnHk_PostMessage,
                        buff, len,
                        NULL,0,
                        &returned,NULL)) {
        retval = FALSE;
    } else {
        retval = TRUE;
    }

    va_end(ap);
    return retval;
} // end DbgDump_Printf()


extern "C"
BOOLEAN
__stdcall
DbgDump_Print(
    PCHAR Msg
    )
{
    ULONG returned;
    if(!DbgDump_i_ConnectDriver())
        return FALSE;

    if(!DeviceIoControl(h_DbgPrintHookDriver, IOCTL_DbgPrnHk_PostMessage,
                        Msg, strlen(Msg),
                        NULL,0,
                        &returned,NULL)) {
        return FALSE;
    }
    return TRUE;
} // end DbgDump_Print()

extern "C"
BOOLEAN
__stdcall
DbgDump_Printn(
    PCHAR Msg,
    ULONG Length
    )
{
    ULONG returned;
    if(!DbgDump_i_ConnectDriver())
        return FALSE;

    if(!DeviceIoControl(h_DbgPrintHookDriver, IOCTL_DbgPrnHk_PostMessage,
                        Msg, Length,
                        NULL,0,
                        &returned,NULL)) {
        return FALSE;
    }
    return TRUE;
} // end DbgDump_Printn()

